function genUUID() {
	var s = [];
	var hexDigits = "0123456789abcdef";
	for (var i = 0; i < 36; i++) {
		s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}
	s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
	s[8] = s[13] = s[18] = s[23] = "-";
	var uuid = s.join("");
	return uuid;
}

//获取设备的唯一码
function getDeviceUUID(){
	var uuid = 'null';
	try{
		uuid = md5(device.uuid);
	}catch(err){
		
		uuid = localStorage.getItem('uuid');
		if(uuid == null || uuid == undefined){
			uuid = md5(genUUID());
			localStorage.setItem('uuid', uuid);
		}
	}
	return uuid;
}

function exitApp(){
	navigator.app.exitApp();
}  

function getDictLength(dict){
	var n = 0;
	for(k in dict){
		n ++;
	}
	return n;
}

function loadImg(imgEle){
	imgEle.load(function(){
		var w = $(this).width();
		var h = $(this).height();
		if(h > w){$(this).css('width', w*w/h);$(this).css('height', w)}
	}).error(function(){
		$(this).parent().parent().remove();
	});
}

function jsonp(url, success){
	$.ajax({
		type : "get",
		async : false,
		url: url,
		dataType : "jsonp",
		jsonp : "callback", 
		jsonpCallback : "handler", 
		success : function(json) { 
			success(json);
		}
	});
}

//检查网络状态
function checkNetworkState(){
	var networkState = navigator.connection.type;
	if (networkState == Connection.NONE) {
		return false;
	}
	return true;
}

var fileTransfer = {
	//FileTransfer对象，依赖FileTransfer插件
	ft : null,
	//调试模式
	debug : 0,
	//创建对象
	start : function(){
		fileTransfer.ft = new FileTransfer();
	},
	//下载
	download : function(uri, fileURL, callback){
		var permissions = window.plugins.permissions;
		permissions.hasPermission(function(status){
			if(!status.hasPermission){
				var errorCallback = function(){
					navigator.notification.alert( '为保证比逗相机的正常使用，请前往系统设置开启比逗相机存储设备的读写权限', '', '提示', '确定');
				}

				permissions.requestPermission(function(status){
					if(!status.hasPermission){errorCallback();}
				},  errorCallback, permissions.WRITE_EXTERNAL_STORAGE);
			} else {
				uri = encodeURI(uri + '?t=' + new Date().getTime());
				fileTransfer.ft.download(
					uri,
					fileURL,
					function(entry) {
						callback(entry.toURL());
					},
					function(error) {
						console.log('文件下载失败！');
					},
					false
					//{ headers: { "Authorization": "Basic "} }
				);
			}
		}, null, permissions.WRITE_EXTERNAL_STORAGE);
	},	

	upload : function(imgData, url, succ, fail, options){
		fileTransfer.ft.upload(imgData, encodeURI(url), succ, fail, options);
	}
};

var cam = {
	type : 'camera',

	options : {
		quality:80,
		destinationType: null,
		sourceType : null,
		saveToPhotoAlbum : true,
		//====关键设置=======================================
		allowEdit:true, //出现裁剪框
		targetWidth:600,//图片裁剪高度
		targetHeight:600,//图片裁剪高度
	},

	init : function(manufacturer, type){
		this.type = type;
		cam.options['sourceType'] = (type == 'camera') ? Camera.PictureSourceType.CAMERA : Camera.PictureSourceType.PHOTOLIBRARY;
		cam.options['saveToPhotoAlbum'] = (type == 'camera') ? true : false;
		cam.options['destinationType'] = Camera.DestinationType.FILE_URI;
		cam.options['allowEdit'] = false;
		if(manufacturer == 'xiaomi' && type == 'camera'){
			cam.options['saveToPhotoAlbum'] = true;
		}
	},	

	start : function(){
		//navigator.camera.getPicture(cam.succ, cam.fail, cam.options);
		if(this.type == 'camera') {
			cordova.cxj009.CustomCamera.getPicture(cam.succ, cam.fail, cam.options);
		} else {
			navigator.camera.getPicture(cam.succ, cam.fail, cam.options);
		}
	},

	succ : function(img){
		//md5chksum.file(img, function(md5sum){console.log("MD5SUM: " + md5sum);}, function(error){console.log("Error-Message: " + error);});
		logger.send('camera_succ', {'msg':img});
		$('.getpicture').hide();
		uploader.init(img);
	},

	fail : function(err){
		logger.send('camera_fail', {'msg':err});
		$('.getpicture').hide();
		$('.mask').hide();
		$('.mask').html('');
	}
};

var uploader = {
	init:function(img){
		dialog.start('换脸中...', false);
		var options = new FileUploadOptions();
		options.fileKey = "file";
		options.fileName = "ishine.jpg";
		options.mimeType = "image/jpeg";
		fileTransfer.upload(
			img, 
			encodeURI("http://" + servDomain + "/identify?uuid=" + uuid), 
			uploader.succ,
			uploader.fail,
			options
		);
		//保存到历史记录
		if(currentPage != 'page-history'){
			var fileURL = '/sdcard/'+appName+'/.history/' + 'IMG_'+(new Date()).getTime()+".jpg";
			fileTransfer.download(img, fileURL, function(localFileURL){
				cordova.CommonTools.refresh(fileURL);
				var key = md5(localFileURL);
				jsonStorage.set('bidou_history_photo', key, localFileURL);
			});
		}
	},
     
	//上传成功的回调
	succ : function(r) {
		if(currentPage == 'page-history'){
			pageHistory.hide();	
		}
		var json_data = eval("(" + r.response + ")"); 
		dialog.end();
		if(json_data.error){
			$('.mask').hide();
			alert(json_data.error);
			dialog.end();
			return false;
		}
		file_md5 = json_data.succ;
		localStorage.setItem('shine_file_md5', file_md5);
		$('.mask').hide();
		timeline.imglist(currentCid, file_md5);
	},
 
	//上传失败的回调
	fail : function(error) {
		dialog.end();
		$('.mask').hide();
		$('.mask').html('');
		alert("上传失败，请重试！");
	}
};

//日志
var logger = {
	ua : navigator.userAgent.toLowerCase(),
	width : screenWidth,
	height : screenHeight,
	pixelratio : window.devicePixelRatio,
	send : function(name, data){
		var t = new Date().getTime();
		var u = getDeviceUUID();
		var img = new Image();
		var content = '';
		for(k in data){
			content +=  '&' + k + '=' + data[k];
		}
		//img.src = 'http://'+pingDomain+'/' + name + '.gif?' + Base64.encode('v='+channelData['v']+'&c='+channelData['id']+'&u=' + u +'&t=' + t + content);
		img.src = 'http://'+pingDomain+'/' + name + '.gif?' + ('v='+channelData['v']+'&c='+channelData['id']+'&u=' + u +'&t=' + t + content);
	}
};

var dialog = {
	start : function(msg, cancelable){
		cordova.plugin.pDialog.init({
			theme : 'DEVICE_LIGHT',
			progressStyle : 'SPINNER',
			cancelable : cancelable,
			title : '',
			message : msg
		});
	},
	end : function(){
		cordova.plugin.pDialog.dismiss();
	},

	prompt : function(msg){
		dialog.start(msg,true);
		setTimeout(function(){dialog.end()}, 500);
	}
};

var updater = {
	url : 'http://'+servDomain+'/update',

	check : function(user_active){
		try{
			cordova.getAppVersion.getVersionCode(function(versionCode) {
				var update_not_prompt = localStorage.getItem('update_not_prompt');
				$.post(updater.url,{},function(data){
					var obj = JSON.parse(data);
					//if(versionCode < obj.versionCode && (update_not_prompt != obj.versionCode)){
					if(versionCode < obj.versionCode){
						if(user_active == 0 && update_not_prompt == obj.versionCode){
							return false;
						} else {
							navigator.notification.confirm(
								obj.msg,
								function(btnIndex){updater.callback(btnIndex, obj.apk, obj.versionCode)},
								'版本升级',
								['升级', '不再提示', '取消']
							);
						}
					} else {
						if(user_active == 1){
							navigator.notification.alert( '已经是最新版本！', '','','确定');
						}
					}
				});
			});
		} catch(e){
			console.log(e);
		}
	},

	callback : function(btnIndex, apkurl, vc){
		if(btnIndex == 1){
			window.open(apkurl, '_system', 'location=yes');
		} else if(btnIndex == 2){
			localStorage.setItem('update_not_prompt', vc);	
		}	
	}
};

//页面切换
var pageSwitch = {
	init:function(){
		$('#btn_setting').click(function(){
			try{cordova.CommonTools.getCacheSize(function(value){console.log(value)});}catch(e){}
			$('.page-entry').hide();
			$('.page-setting').show();
			if(settingPage.isInit == 0){
				settingPage.init();
				//反馈	
				feedback.init(uuid, device);
			}
			cameraButton.hide();
			currentPage = 'page-setting';
		});

		$('.btn_back').click(function(){
			var hide_page = $(this).parent().parent();
			var show_page = $('.'+$(this).attr('back'));
			if(currentPage == 'page-clause'){
				$('.page-clause .content').html('');
			}else if(currentPage == 'page-history'){
				pageHistory.hide();
			}else if(currentPage == 'page-faces'){
				$('.page-faces .content li').unbind();
				$('.page-faces .content').html('');
			}
			if($(this).attr('back') == 'page-faces' || $(this).attr('back') == 'page-entry'){cameraButton.show();}
			show_page.show();
			hide_page.hide();
			currentPage = $(this).attr('back');
		});
	}
};

var timeline = {
	error : function(ele){
		if(!checkNetworkState()){
			//dialog.end();
			ele.html('<div class="error">网络信号弱或网页不存在</div>');
			return true;
		}
	},

	tags:function(){
		var html = '';
		var ele = $('.page-entry .content');
		if(this.error(ele)) {return;}
		ele.height(screenHeight);
		jsonp('http://' + servDomain + '/index?uuid='+uuid,function(json){
			jsonData = JSON.parse(json).data;
			var len = $.map(jsonData, function(n, i) { return i; }).length;
			for(k in jsonData){
				var title = jsonData[k]['title'];
				var items = jsonData[k]['items'];
				html += '<h3>' + title + '</h3>';
				html += '<div class="tags_block"><ul>';
				for(j in items){
					var item = items[j];
					html += '<li cid="'+item['id']+'"><div><img class="lazy" src="'+item['img']+'" /></div>' + item['name'] + '</li>';
					if(currentCid == 0){currentCid = j;}
				}
				html += '<ul></div><line></line>';
			}
			ele.html(html);
			$('.tags_block ul li').click(function(){
				var cid = $(this).attr('cid');
				timeline.imglist(cid, file_md5);
				cordova.Umeng.setEventCount('tagclick', cid);
			});
			cameraButton.show();
			currentPage = 'page-entry';
		});
	},

	imglist:function(cid, md5){
		try{dialog.start('数据加载中...', false);}catch(e){}
		var ele = $('.page-faces .content');
		if(this.error(ele)) {return;}
		var imgpath = '/shine/' + uuid.substr(0,2) + '/' + uuid + '/';
		currentCid = cid;
		$('.page-faces').show();
		ele.height(screenHeight);
		jsonp('http://' + servDomain + '/list?cid='+cid+'&u='+uuid+'&md5='+md5,function(json){
			jsonData = JSON.parse(json).data;
			$('.page-faces .titlebar b').text(jsonData.title);
			var items = jsonData.items;	
			var html = '<ul>';
			for(k in items){
				var tplId = items[k]['id'];
				var staticURL = md5 ? 'http://' + imgDomain + imgpath + cid + '_' + tplId + '.jpg': 'http://' + imgDomain + '/shinetpl/' + cid + '/' + cid + '_' + tplId + '.jpg';
				html += '<li><div><img class="lazy" staticurl="'+staticURL+'" id="img_'+cid+'_'+tplId+'" src="'+items[k]['url']+'" /></div></li>';	
			}
			html += '</ul>';
			ele.html(html);
			loadImg($('img.lazy'));
			//$("img.lazy").lazyload({container: $('.imglist .content')});
			try{dialog.end();}catch(e){}
			cameraButton.show();

			currentPage = 'page-faces';

			$('.page-faces .content ul li').click(function(){
				share.shareId = $(this).children('div').children('img').attr('id');
				if(share.isInit == 0){
					share.init();
				}
				share.showPreview(md5);
				cordova.Umeng.setEventCount('imgclick', share.shareId);
			});
		});
	},
}

function switchFace() {
	$('.getpicture div').click(function(){
		var type = $(this).attr('type');
		if(type == 'camera' || type == 'album'){
			var permissions = window.plugins.permissions;
			cordova.Umeng.setEventCount('btnclick', '换脸_'+type);
			permissions.hasPermission(function(status){
				if(!status.hasPermission){
					var errorCallback = function(){
						navigator.notification.alert(
							'为保证比逗相机的正常使用，请前往系统设置开启比逗相机使用摄像头的权限', '', '提示', '确定'
						);
					}

					permissions.requestPermission(function(status){
						if(!status.hasPermission){errorCallback();}
					},  errorCallback, permissions.CAMERA);
				} else {
					cam.init(manufacturer, type);
					cam.start();
				}
			}, null, permissions.CAMERA);
		} else if(type == 'cancel'){
			$('.mask').hide();
			$('.getpicture').hide();
			cordova.Umeng.setEventCount('btnclick', '换脸_取消');
		} else if(type == 'history'){
			pageHistory.show();
			cordova.Umeng.setEventCount('btnclick', '换脸_历史');
		}
	});
}

var pageHistory = {
	show : function(){
		cameraButton.hide();
		$('.page-history .titlebar a').attr('back', currentPage);
		$('.mask').hide();
		$('.getpicture').hide();
		$('.page-faces').hide();
		$('.page-history').show();
		$('.page-history .titlebar span').text('编辑');
		var imglist = jsonStorage.get('bidou_history_photo');
		//var html = '<div><ul>';
		var n = 0;
		var html = '';
		for(key in imglist){
			n ++;
			var img = imglist[key];
			var line = '<li id="key_'+key+'"><div><img class="history_photo" src="'+img+'" /></div><b class="button_close"></b></li>';
			html = line.concat(html);
		}
		html = '<div><ul>'+html+'</ul></div>';
		if(n == 0){
			this.showNoHistory();
			$('.page-history .titlebar span').text('');
		} else {
			$('.page-history .content').html(html);
			loadImg($('.history_photo'));
			this.edit();
			this.select();
		}
		currentPage = 'page-history';
	},
	
	showNoHistory : function(){
		$('.page-history .content').html('<div class="no_history"><img src="./img/no_history.png" width="60%" /></div>');
	},

	hide : function(){
		$('.page-history .content ul li').unbind();
		$('.page-history .button_close').unbind();
		$('.page-history .titlebar span').unbind();
		$('.page-history .content').html('');
		$('.page-history').hide();
	},

	//选择历史照片
	select : function(){
		$('.page-history .content ul li').click(function(){
			var img = $(this).children('div').children('img').attr('src');
			uploader.init(img);
			cordova.Umeng.setEventCount('btnclick', '历史_选择照片');
		});		
	},

	edit : function(){
		$('.page-history .titlebar span').click(function(){
			if($(this).text() == '编辑'){
				$(this).text('完成');
				$('.page-history .content ul li').unbind();
				$('.page-history .button_close').show();
				pageHistory.delItem();
			} else {
				$(this).text('编辑');
				$('.page-history .button_close').unbind();
				$('.page-history .button_close').hide();
				pageHistory.select();
			}
		});
	},

	delItem : function(){
		$('.page-history .button_close').click(function(){
			var key = $(this).parent().attr('id').replace('key_', '');
			rs = jsonStorage.del('bidou_history_photo', key);
			$(this).parent().remove();
			if(getDictLength(rs) == 0){
				pageHistory.showNoHistory();
				$('.page-history .titlebar span').text('');
			}
		});
	}
	
}

//读取&保存数组到localstorage
var jsonStorage = {
	set:function(name, key, value){
		dict = this.get(name);
		dict[key]= value;
		localStorage.setItem(name, JSON.stringify(dict));
	},

	get:function(name){
		var rs = '';
		var dict = {};
		var json = localStorage.getItem(name);
		if(json){
			try{rs = JSON.parse(json);}catch(e){console.log(e)}
		}
		if(typeof(rs) == 'object'){
			dict = rs;	
		}
		return dict;
	},
	
	del:function(name, key){
		dict = {}
		dictOld = this.get(name);
		for(k in dictOld){
			if(k != key){
				dict[k] = dictOld[k];
			}	
		}		
		localStorage.setItem(name, JSON.stringify(dict));
		return dict;
	}
}

//拍照按钮的显示隐藏和触发
var cameraButton = {
	ele : '',
	
	init : function(){
		this.ele = $('#camera_button');
		this.ele.css('left', screenWidth / 2 - 30);
		this.start();
	},

	//显示
	show : function(){
		if(this.ele.css('display') == 'none'){
			this.ele.fadeIn();
			this.showPopTip();
		}
	},

	//隐藏
	hide : function(){
		this.ele.hide();
	},

	start : function(){
		this.ele.click(function(){
			try{cordova.Umeng.setEventCount('btnclick', '换脸');}catch(e){}
			$('.mask').show();
			$('.getpicture').show();
			$('.mask').click(function(){
				$('.mask').hide();
				$('.getpicture').hide();	
			});
			
			var showGuideTip = localStorage.getItem('guidetip');
			if(showGuideTip == null || showGuideTip == undefined) {
				localStorage.setItem('guidetip', 1);
				$('#poptip').fadeOut();
			}
		});
	},

	showPopTip : function(){
		showGuideTip = localStorage.getItem('guidetip');
		if(showGuideTip != 1){
			setTimeout(function(){
				$('#poptip').css('left', screenWidth /2 - 125);
				$('#poptip').fadeIn('slow');
				setTimeout(function(){$('#poptip').fadeOut('slow')}, 5000);
			}, 500);
		}
	}
}

//后退键
function onBackButton() {
	if(currentPage == 'page-entry' || currentPage == ''){
		window.plugins.toast.showShortBottom('再按一次退出程序'), 
		document.removeEventListener("backbutton", onBackButton, false); // 注销返回键
		document.addEventListener("backbutton", exitApp, false);//绑定退出事件
		// 3秒后重新注册
		var intervalID = window.setInterval(function() {
			window.clearInterval(intervalID);
			document.removeEventListener("backbutton", exitApp, false); // 注销返回键
			document.addEventListener("backbutton", onBackButton, false); // 返回键
		}, 3000);
	} else {
		$('.'+currentPage + ' .titlebar .btn_back').trigger('click');
	}

}
